Index: /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java	(revision 33588)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/javaClassifierComparison.java	(revision 33589)
@@ -872,3 +755,263 @@
         }
     }
+
+    //******************
+    //OLD FUNCTIONS
+    //******************
+    private static Pair Algorithm_MorphologyOLD2(String filename){
+
+        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
+        Boolean isSheetMusic = null;
+        Pair returnVariables = new Pair();
+        int areaCounter = 0;
+        try{
+            Mat edgesDetectedRGB = new Mat();
+            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+
+            System.out.println("Width: " + original.width() + " Height: " + original.height());
+
+            ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
+            Mat hierarchy = new Mat();
+
+            //Thresholds
+            Imgproc.adaptiveThreshold(original, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+            Mat processed = original.clone();
+            //Morphological Processing
+            Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,1));
+            Imgproc.erode(processed,processed,kernelErode);
+
+            Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(20,3));
+            Imgproc.dilate(processed,processed,kernelDilate);
+
+            Mat kernelOpening = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
+            Imgproc.morphologyEx(processed, processed, Imgproc.MORPH_CLOSE, kernelOpening);
+
+            Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8,8));
+            Imgproc.erode(processed,processed,kernelErode02);
+
+            //Detect contours
+            Imgproc.findContours(processed, contours, hierarchy, Imgproc.RETR_TREE, Imgproc.CHAIN_APPROX_SIMPLE);
+
+            //Record areas
+            for (int i = 0; i < contours.size(); i++) {
+                double area = Imgproc.contourArea(contours.get(i));
+                System.out.println("AREA: " + area);
+                //Check if area detected meets threshold
+                if(area > THRESHOLD_AREA_SIZE) {
+                    areaCounter++;
+
+                }
+            }
+            System.out.println("areacount = " + areaCounter);
+
+            //Calculates if sheet music or not
+            if(areaCounter >= THRESHOLD_AREA_COUNT){
+                isSheetMusic = true;
+                returnVariables.setBoolean(isSheetMusic);
+                returnVariables.setInteger(areaCounter);
+            }
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+        return returnVariables;
+    }
+    private static Pair Algorithm_MorphologyOLD(String filename){
+
+        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
+        Boolean isSheetMusic = null;
+        Pair returnVariables = new Pair();
+        int FILLED = -1;
+        try{
+            Mat original1 = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
+            System.out.println("Width: " + original1.width() + " Height: " + original1.height());
+            Mat original = original1.clone();
+            Imgproc.adaptiveThreshold(original1, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
+            Mat test = original.clone();
+            //************************************
+            //Large Object Removal
+            //************************************
+            Mat srcLOR = original.clone();
+            Mat maskLOR = new Mat();
+            Mat dstLOR = new Mat();
+
+            //denoize
+            Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
+            Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, denoize);
+
+            //close up gaps
+            Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
+            Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_CLOSE, gapCloser);
+
+            //Isolate large items
+            Mat isolateLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8, 8));
+            Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_OPEN, isolateLarge);
+
+            //Remove large items from image
+            Core.bitwise_not(maskLOR,maskLOR);
+            srcLOR.copyTo(dstLOR, maskLOR);
+
+            //****************************************
+            //Small object removal (SOR)
+            //****************************************
+
+            Mat srcSOR = dstLOR.clone();
+            Mat maskSOR = new Mat();
+            Mat dstSOR = new Mat();
+
+            Mat startSOR =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
+            Imgproc.morphologyEx(srcSOR,maskSOR, Imgproc.MORPH_OPEN, startSOR);
+
+            Mat highlightSmall = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
+            Imgproc.dilate(maskSOR, maskSOR, highlightSmall);
+
+
+/*              Mat isolateSmall =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
+                Imgproc.morphologyEx(maskSOR,maskSOR,Imgproc.MORPH_CLOSE, isolateSmall);
+                imageViewer("13 isolate small - mask", maskSOR);
+*/
+
+            //Remove small items from image
+            Core.bitwise_not(maskSOR, maskSOR);
+            srcSOR.copyTo(dstSOR, maskSOR);
+
+
+            //****************************************
+            //start staff line detection
+            //****************************************
+
+            Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(15,2)); //10,2
+            Imgproc.erode(dstSOR,test,kernelErode);
+
+
+            Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //20,3
+            Imgproc.dilate(test,test,kernelDilate);
+
+
+            Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
+            Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelClose);
+
+
+
+            Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //10,1
+            Imgproc.erode(test,test,kernelErode02);
+
+
+            //********************************************************************************
+            //DETECT OUTLINE AND FIND AREA OF THESE LINES.
+            //********************************************************************************
+            ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
+            ArrayList<MatOfPoint> largeContours = new ArrayList<MatOfPoint>();
+            ArrayList<MatOfPoint> postContours = new ArrayList<MatOfPoint>();
+            Mat hierarchy = new Mat();
+
+            //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
+            //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
+            //(hierarchy) output array:           Optional output vector, containing information about the image topology.
+            //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a
+
+            Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
+
+            System.out.println(contours.size());
+            //Draw contours and record areas
+            Mat allContoursFound = Mat.zeros(test.size(), CvType.CV_8UC3);
+            Mat largeContoursFound = allContoursFound.clone() ;
+            Mat postContoursFound = allContoursFound.clone();
+            int areaCounter = 0;
+
+            //Have created a preprocess to remove large objects.
+            //Need to now finalized Classifier, re try area detection.
+            //Paths to take - rectangle boxes around detected contours over threshold (area or perimeter)
+            //Just use area and periemter to determine if sheet music
+            //Discuss with david before weekend perhaps?
+
+            Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
+            for (int i = 0; i < contours.size(); i++) {
+                double area = Imgproc.contourArea(contours.get(i));
+                if(area > 100) {
+                    //System.out.println("AREA: " + area);
+                    Imgproc.drawContours(largeContoursFound, contours, i, new Scalar(255, 0, 0), FILLED);
+                    //create list of large coutours found
+                    largeContours.add(contours.get(i));
+                }
+            }
+
+            //*****************************************************************
+            //Circles and centres on processed images
+            //*****************************************************************
+
+            //Init arrays
+            Mat circleOutput = allContoursFound.clone();
+            MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[largeContours.size()];
+            Point[] centers = new Point[largeContours.size()];
+            float[][] radius = new float[largeContours.size()][1];
+
+            //Fill arrays
+            for (int i = 0; i < largeContours.size(); i++) {
+                contoursPoly[i] = new MatOfPoint2f();
+                Imgproc.approxPolyDP(new MatOfPoint2f(largeContours.get(i).toArray()), contoursPoly[i], 1, true);
+                centers[i] = new Point();
+                Imgproc.minEnclosingCircle(contoursPoly[i], centers[i], radius[i]);
+
+            }
+            //Draw circle for each large contour
+            for (int i = 0; i < largeContours.size(); i++) {
+                Imgproc.circle(circleOutput, centers[i], (int) radius[i][0],new Scalar(255, 0, 0), 1);
+            }
+
+
+            //********************************************************************************
+            //Centroids - Everything must be to scale
+            //********************************************************************************
+
+            ArrayList<Moments> mu = new ArrayList<Moments>(largeContours.size());
+            Mat centreOutput = Mat.zeros(largeContoursFound.size(), CvType.CV_8UC3);
+            for (int i = 0; i < largeContours.size(); i++) {
+                mu.add(i, Imgproc.moments(largeContours.get(i), false));
+                Moments p = mu.get(i);
+                int x = (int) (p.get_m10() / p.get_m00());
+                int y = (int) (p.get_m01() / p.get_m00());
+                Imgproc.circle(centreOutput, new Point(x, y), 4, new Scalar(255, 255, 255), 30);
+            }
+
+            //***********************************************
+            //PostProcessing - Morphology Classifier
+            //  Use dilation to "Connect the dots"
+            //  Testing showed the centroids were clustered together
+            //  Then use area or perimeter as a classifier filter
+            //***********************************************
+
+            Mat postDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(150,15));
+            Imgproc.dilate(centreOutput,centreOutput,postDilate);
+
+            Mat postClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
+            Imgproc.morphologyEx(centreOutput, centreOutput, Imgproc.MORPH_CLOSE, postClose);
+
+            Mat postDenoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,100));
+            Imgproc.morphologyEx(centreOutput,centreOutput, Imgproc.MORPH_OPEN, postDenoize);
+
+            //Find area
+            Mat centreOutputGrey = new Mat();
+            Imgproc.cvtColor(centreOutput, centreOutputGrey, Imgproc.COLOR_RGB2GRAY);
+            Imgproc.findContours(centreOutputGrey, postContours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
+
+            for (int i = 0; i < postContours.size(); i++) {
+                double area = Imgproc.contourArea(postContours.get(i));
+                if(area > THRESHOLD_AREA_SIZE) {
+                    //System.err.println("POST AREA: " + area);
+                    Imgproc.drawContours(postContoursFound, postContours, i, new Scalar(0, 255, 0), FILLED);
+                    areaCounter++;
+                }
+            }
+            //Classifier Calculation
+            if(areaCounter >= THRESHOLD_AREA_COUNT){
+                returnVariables.setBoolean(true);
+                returnVariables.setInteger(areaCounter);
+            }
+        }
+        catch(Exception e){
+            System.err.println(e);
+        }
+        return returnVariables;
+    }
 }
Index: /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh	(revision 33588)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-terminal/runClassifer.sh	(revision 33589)
@@ -1,12 +1,19 @@
 #!/bin/bash
+#https://www.cyberciti.biz/faq/linux-unix-shell-check-if-directory-empty/
 
-if [ $# != 4 ] ; then 
-  echo "Usage: ./testClassifier.sh folder/file classifier_type output_filename  type(-a:all -test:100 -single:1)" 1>&2
+if [ $# -lt 4 ] ; then 
+  echo "Usage: ./testClassifier.sh  <folder/file> <classifier_type> <output_filename> <amount>" 1>&2
+  echo "<amount> options: -a (all) -test (100) -single (1)"
   exit 1
 fi
-
+if [ $# -eq 5 ] ; then
+	borderIgnore=$5
+fi
 source=$1
 classifier_type=$2
 output=$3
+
+
+
 i=0
 j=0
@@ -68,24 +75,35 @@
 		javac -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar -Xlint javaClassifierComparison.java;
 		#Runs javaImageClassifier on 10 images of each
-		for file in $source/SheetMusic/*.png; do
-			if [ $i -lt 100 ] ; then
-				echo $file
-				echo $output
-				echo $i
-				echo ""
-				java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $file $classifier_type $output
-				i=$[$i+1]		
-			fi
-		done
-		for file in $source/NotSheetMusic/*.png; do
-			if [ $j -lt 100 ] ; then
-				echo $file
-				echo $output
-				echo $j
-				echo ""
-				java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $file $classifier_type $output
-				j=$[$j+1]		
-			fi
-		done
+		if [ "$(ls -A $source/SheetMusic)" ]; then
+    		#Not Empty
+    		for file in $source/SheetMusic/*.png; do
+				if [ $i -lt 10 ] ; then
+					echo $file
+					echo $output
+					echo $i
+					echo ""
+					java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $file $classifier_type $output
+					i=$[$i+1]		
+				fi
+			done
+		else
+    		echo "$source/SheetMusic is Empty"
+		fi
+		
+		if [ "$(ls -A $source/NotSheetMusic)" ]; then
+    		#Not Empty
+			for file in $source/NotSheetMusic/*.png; do
+				if [ $j -lt 10 ] ; then
+					echo $file
+					echo $output
+					echo $j
+					echo ""
+					java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $file $classifier_type $output
+					j=$[$j+1]		
+				fi
+			done
+		else
+    		echo "$source/NotSheetMusic is Empty"
+		fi
 		;;
 #________________________________________________________________________________________________________________________________________________________________________________________
@@ -107,5 +125,6 @@
 		echo $output
 		echo $classifier_type
-		java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $source $classifier_type $output
+		echo $borderIgnore
+		java -cp /Scratch/cpb16/opencv-3.4.2/build/bin/opencv-342.jar:. -Djava.library.path=/Scratch/cpb16/opencv-3.4.2/build/lib/  javaClassifierComparison $source $classifier_type $output $borderIgnore
 		;;	
 esac		
